#include     <stdio.h>      /*׼*/
#include     <stdlib.h>     /*׼ⶨ*/
#include     <unistd.h>     /*Unix ׼*/
#include     <sys/types.h>  
#include     <sys/stat.h>   
#include     <fcntl.h>      /*ļƶ*/
#include     <termios.h>    /*PPSIX ն˿ƶ*/
#include     <errno.h>      /*Ŷ*/
#include 	 <sys/time.h> 
#include	 <time.h>
#include     <stdbool.h>
#include      <sys/sem.h>

void Delay(int ms);
int ReadData(int fd, unsigned char *read_buff, int count, int ms);
int WriteData(int fd, unsigned char *read_buff, int count);
unsigned short Read_LW(unsigned int n);
void Write_LW(unsigned int n,unsigned short val);
void CopyToLW(unsigned int offset,const void *src, int n);
void CopyFromLW(unsigned int offset,const void *src, int n);
void SetLBON(unsigned int n);
void SetLBOFF(unsigned int n);
int GetLB(unsigned int n);
int SetLWBON(unsigned int n, unsigned int offset);
int SetLWBOFF(unsigned int n, unsigned int offset);
int GetLWB(unsigned int n, unsigned int offset);
void Write_LW_ALL(unsigned int n,unsigned short val);
int Write_Rw( void *buf, int addr, int nWords );
int Read_Rw( void *buf, int addr, int nWords );

unsigned short G_TM=0; //ÿ100msѭ
unsigned short G_COUNT=0;//ƵдַǼǸ
//ƵдַǼ
unsigned short G_ADDR[50]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
						};

//LRC
unsigned char  LRC(unsigned char* data,int number)
{
	unsigned char uchLRC=0;// FCS ֽڳʼ 
	if (number < 0)
		return -1;

	uchLRC = uchLRC ^ 0xff ; // ۼ
	
	while(number--)
	{
		uchLRC = uchLRC ^ (*data++) ; // ۼ
		//printf("uchLRC=%d",uchLRC);
	}
	return (uchLRC);
}

static inline unsigned char dec_to_ascii(unsigned int val)
{
	if((val>=0)&&(val<=9))
	{
		return (val+0x30);
	}
	if((val>=10)&&(val<=15))
		return (val+0x37);
}

static inline unsigned char ascii_to_dec(unsigned int val)
{
	if((val>=48)&&(val<=57))
		return (val-0x30);
	if((val>=65)&&(val<=70))
		return (val-0x37);
	if((val>=97)&&(val<=102))
		return (val-0x57);
}

//ƵдַǼ
void Drive_register()
{
	int w_addr=0;
	int w_len=0;
	int i,j;
	int flag=0;
	
	w_len=Read_LW(9376); //дݸ

	if(w_len>0) //ݸı
	{
		
		for (i=0; i<w_len; i++)
		{
			w_addr=Read_LW(9375);
		
			for(j=0;j<50;j++)	
			{
				if(G_ADDR[j]==w_addr)
				{
					flag=1;
					break;
				}
			}

			if(flag==0)
			{
				G_ADDR[G_COUNT]=w_addr;
				G_COUNT++;
				
			}
		
			
		}

	}


}

//Ƶ֡
void Write_To_Drive(int fd,unsigned short addr)
{
	
	unsigned char send_data[100];
	int i,j;
	int LRC_result;
	int id=0;
	
	for(i=0;i<2;i++)
	{
		send_data[0]=0xA5;		
		send_data[1]=dec_to_ascii((unsigned char)((id)>>4)&0xf); //վ
		send_data[2]=dec_to_ascii((unsigned char)((id)&0xf));		
		send_data[3]=dec_to_ascii((unsigned char)((addr-8000)>>4)&0xf); //ַ
		send_data[4]=dec_to_ascii((unsigned char)((addr-8000)&0xf));
		send_data[5]=dec_to_ascii((unsigned char)((Read_LW(addr))>>12)&0xf); //ֵ
		send_data[6]=dec_to_ascii((unsigned char)((Read_LW(addr))>>8)&0xf);
		send_data[7]=dec_to_ascii((unsigned char)((Read_LW(addr))>>4)&0xf);		
		send_data[8]=dec_to_ascii((unsigned char)((Read_LW(addr))&0xf));
					
		LRC_result=LRC(( send_data+1),8);
		send_data[9]=dec_to_ascii((unsigned char)(LRC_result>>4));
		send_data[10]=dec_to_ascii((unsigned char)(LRC_result&0xf));
				

		WriteData(fd, send_data, 11);
		if (Read_LW(101)<=50)
			Delay(50);
		else
			Delay(Read_LW(101));//ʱ50ms

		id++;

		
	}


}


void ProcessComx(int fd)
{	
	unsigned char send_data[1024];
	int i,j,k;
	int LRC_result;
	int count=3;//ѭ
	int w_cnt=0;
	int w_addr=0;
	int bIsInput = 0;
	int tm_count=0; //ѭ趨ֵ
	int tm_val=0; //ѭ
	
	//printf("COM0 Working...\r\n");
	
//дСѭ
	if (Read_LW(100)<=3)
		count=3;
	else
		count=Read_LW(100);//ѭ

	w_cnt=Read_LW(9376); //дݸ

	if(w_cnt>0) //ݸı
	{
		Drive_register();//ƵдַǼ
WR:
	
		for(j=0;j<count;j++)
		{
			for (i=0; i<w_cnt; i++)
			{
		
				Write_To_Drive(fd,(Read_LW(9375)+i));//Ƶ֡
				bIsInput = 1;
			}

		}

		if (bIsInput == 1) //дݸ
			Write_LW_ALL(9376,0);
				
		G_TM=0;
	
	}
	else
	{
		Delay(100); //ÿ100msѭ
		G_TM++;
		
	}


//ÿ10 S ѭ
	if (Read_LW(102)<=100)
		tm_count=100;
	else
		tm_count=Read_LW(102);//ѭ100 x100ms
	
	if(G_TM>=tm_count) //ÿ10 S ѭ
	{

		for(j=0;j<count;j++)
		{
			for (i=0; i<G_COUNT; i++)
			{
				
				Write_To_Drive(fd,G_ADDR[ i]);
				
				w_cnt=Read_LW(9376); //дݸ
				
				if(w_cnt>0)
					goto WR; //ֹѭִСѭ
				
			}
			
		}

		G_TM=0;

	}
			
	
}

int Read_Rw( void *buf, int addr, int nWords )
{
  int ret = -1;
  int fd;
  if((fd = open("/dev/sram-mmap0", O_RDWR))==-1)
	{
		if((fd = open("/mount/data/sram-mmap", O_RDWR))==-1)
		{
			if((fd = open("/dev/sram-mmap", O_RDWR))==-1)
			{
				printf("Cann't open file sram-mmap \n"); 
				return -1;
			}
		}
	}
  if((addr+nWords)>130500)return ret;  
  if ( fd > 0 )
  {
    lseek( fd, 0x400+addr*2, 0 );
    ret = read( fd, buf, nWords*2);
    close( fd );
  }
  return ret;
}

int Write_Rw( void *buf, int addr, int nWords )
{
  int ret = -1;
  int fd;
	if((fd = open("/dev/sram-mmap0", O_RDWR))==-1)
	{
		if((fd = open("/mount/data/sram-mmap", O_RDWR))==-1)
		{
			if((fd = open("/dev/sram-mmap", O_RDWR))==-1)
			{
				printf("Cann't open file sram-mmap \n"); 
				return -1;
			}
		}
	}
  if((addr+nWords)>130500)return ret;  
  if ( fd > 0 )
  {
    lseek( fd, 0x400+addr*2, 0 );
    ret = write( fd, buf, nWords*2);
    close( fd );
  }
  return ret;
}
